/**
 * you can put a one sentence description of your library here.
 *
 * (c) 2011
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA  02111-1307  USA
 * 
 * @author		
 * @modified	07/03/2011
 * @version		0.1.6
 */

package processing.android.dandelion;

import java.io.IOException;
import java.lang.reflect.Method;
import java.util.Set;
import java.util.UUID;
import java.util.Vector;



import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Handler;
import android.os.Looper;
import android.util.Log;

/**
 * This is a template class and can be used to start a new processing library or
 * tool. Make sure you rename this class as well as the name of the example
 * package 'template' to your own lobrary or tool naming convention.
 * 
 * @example Hello
 * 
 *          (the tag @example followed by the name of an example included in
 *          folder 'examples' will automatically include the example in the
 *          javadoc.)
 * 
 */

/* TODO */
// ** available()
// ** read()
// ** connect()
// ** readChar()
// ** readBytes()
// readBytesUntil()
// readString()
// readStringUntil()
// ** buffer()
// bufferUntil()
// ** last()
// ** lastChar()
// ** list()
// ** write()
// ** clear()
// ** stop()
// btSerialEvent()

public class Dandelion {

	/* PApplet context */
	private Context ctx;

	public final static String VERSION = "0.1.6";
	
	private final Client client;

	/* Bluetooth */
	private BluetoothAdapter mAdapter;
	private BluetoothDevice mDevice;
	private UUID uuid = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");

	/* Socket & streams for BT communication */
	private BluetoothSocket mSocket;
	private ConnectedThread mConnectedThread;
	private boolean connected = false;

	/* Buffer */
	private int bufferlength = 128;
	private int available = 0;
	private byte[] buffer;
	private byte[] rawbuffer;

	/* Debug variables */
	public static boolean DEBUG = false;
	public static String DEBUGTAG = "btserial 0.1.6 Debug message: ";
	
	
	Method DandelionDigitalInputMethod;
	Method DandelionAnalogInputMethod;
	
	public int[] analogInput=new int[2];
	public boolean[] digitalInput=new boolean[10];
	
	public boolean[] digitalOutput=new boolean[10];
	
	public static boolean continuousMode = false; // added by morecat
	
	private StringBuffer sReturnCodes = new StringBuffer();

	
//	public BtSerial(Context ctx) {
//		this.ctx = ctx;
//		welcome();
//		mAdapter = BluetoothAdapter.getDefaultAdapter();
//		/* Init the adapter */
//		new Handler(Looper.getMainLooper()).post(new Runnable() {
//			@Override
//			public void run() {
//				//mAdapter = BluetoothAdapter.getDefaultAdapter();
//			}
//		});
//	}
	
	/**
	 * a Constructor, used to establish a connection to a Dandelion
	 * the library will look for its path.
	 * @param theParent
	 *          use "this".
	 */
	public Dandelion(Context ctx) {
		this.ctx = ctx;	
		client = new Client(this);
		
		
		String[] pairedDevices = client.list();
		
		
		
		client.connect(pairedDevices[0]);
		
		
	/*	if(client.findDandelion()){			
			initialize();
		}else{
			errorMessage("Dandelion not found !!");
		}*/
		
		//parent.registerDispose(this);
	}
	
	public Dandelion(Context ctx,int num) {
		this.ctx = ctx;	
		client = new Client(this);
			
		String[] pairedDevices = client.list();
			
		client.connect(pairedDevices[num]);
				
	}
	

	/**
	 * Returns the status of the connection.
	 * 
	 * @return
	 */
	public boolean isConnected() {
		return connected;
	}

	/**
	 * Returns whether the adapter is enabled.
	 * 
	 * @return
	 */
	public boolean isEnabled() {
		if (mAdapter!=null) 
			return mAdapter.isEnabled();
		else return false;
	}

	/**
	 * Returns the list of bonded devices.
	 * 
	 * @return
	 */


	public String[] list() {
		return client.list();
	}

	/*
	 * Some stubs for future implementation:
	 * 
	 */
	public void startDiscovery() {
		// this method will start a separate thread to handle discovery
	}

	public void pairWith(String thisAddress) {
		// this method will pair with a device given a MAC address
	}
	public boolean discoveryComplete() {
		// this method will return whether discovery is complete,
		// so the user can then list devices
		return false;
	}


	public String getName() {
		if (mDevice !=null) return mDevice.getName();
		else return "no device connected";
	}



	/**
	 * Returns the available number of bytes in the buffer.
	 * 
	 * @return
	 */
	public int available() {
		return client.available();
	}

	/**
	 * 
	 */
	private void welcome() {
		System.out.println("Dandelion for android");
	}

	/**
	 * return the version of the library.
	 * 
	 * @return String
	 */
	public static String version() {
		return VERSION;
	}


	/**
	 * Writes a byte[] buffer to the output stream.
	 * 
	 * @param buffer
	 */
	public  void write(byte[] buffer) {
		client.write(buffer);
	}

	/**
	 * Writes a  String to the output stream.
	 * 
	 * @param thisString
	 */
	public  void write(String thisString) {
		byte[] thisBuffer = thisString.getBytes();
		client.write(thisBuffer);
	}

	/**
	 * Writes a  String to the output stream.
	 * 
	 * @param buffer
	 */
	public  void write(int thisInt) {
		byte[] thisBuffer = {(byte)thisInt};
		client.write(thisBuffer);
	}
	/**
	 * Returns the first available byte in "buffer" and then removes it.
	 * 
	 * @return
	 */
	private int readByte() {
		return client.readByte();
	}

	/**
	 * Returns the next byte in the buffer as an int (0-255);
	 * 
	 * @return
	 */
	public int read() {
		return readByte();
	}

	/**
	 * Returns the whole byte buffer.
	 * 
	 * @return
	 */
	public byte[] readBytes() {
		return client.readBytes();
	}

	/**
	 * Returns the available number of bytes in the buffer, and copies the
	 * buffer contents to the passed byte[]
	 * 
	 * @param buffer
	 * @return
	 */
	public int readBytes(byte[] buffer) {
		buffer = this.buffer.clone();
		return available;
	}

	/**
	 * Returns a bytebuffer until the byte b. If the byte b doesn't exist in the
	 * current buffer, null is returned.
	 * 
	 * @param b
	 * @return
	 */
	public byte[] readBytesUntil(byte b) {
		/* Read the buffer until the value 'b' is found */
		for (int i = 0; i < buffer.length; i++) {
			if (buffer[i] == b) {
				/* Found the byte, buffer until this index, and return */
				byte[] returnbuffer = new byte[i];
				/* Populate the returnbuffer */
				for (int j = 0; j < returnbuffer.length; j++) {
					returnbuffer[j] = buffer[j];
				}

				/* Return buffer */
				return returnbuffer;
			}
		}
		return null;
	}

	/**
	 * TODO
	 * 
	 * @param b
	 * @param buffer
	 */
	public void readBytesUntil(byte b, byte[] buffer) {
		if (DEBUG) Log.i("System.out", "Will do a.s.a.p.");
	}

	/**
	 * Returns the next byte in the buffer as a char, if nothing is there it
	 * returns -1.
	 * 
	 * @return
	 */
	public char readChar() {
		return (char) readByte();
	}

	/**
	 * Returns the buffer as a string.
	 * 
	 * @return
	 */
	public String readString() {
		String returnstring = null;

		for (int i = 0; i < buffer.length; i++)
			returnstring += (char) buffer[i];

		return returnstring;
	}

	/**
	 * Returns the buffer as string until character c.
	 * 
	 * @param c
	 * @return
	 */
	public String readStringUntil(char c) {
		/* Get the buffer as string */
		String stringbuffer = readString();

		int index;
		/* Make sure that the character exists in the string */
		if ((index = stringbuffer.indexOf(c)) > 0) {
			return stringbuffer.substring(0, index);
		} else {
			return null;
		}
	}

	/**
	 * Sets the number of bytes to buffer.
	 * 
	 * @param bytes
	 * @return
	 */
	public int buffer(int bytes) {
		bufferlength = bytes;

		buffer = new byte[bytes];
		rawbuffer = buffer.clone();

		return bytes;
	}

	/**
	 * Returns the last byte in the buffer.
	 * 
	 * @return
	 */
	public int last() {
		return buffer[buffer.length - 1];
	}

	/**
	 * Returns the last byte in the buffer as char.
	 * 
	 * @return
	 */
	public char lastChar() {
		return (char) buffer[buffer.length - 1];
	}

	/**
	 * Clears the byte buffer.
	 */
	public void clear() {
		buffer = new byte[bufferlength];
	}

	/**
	 * Disconnects the bluetooth socket.
	 * 

	 */
	public synchronized void disconnect() {
		if (connected) {
			try {
				// kill the connected thread if it's running:
				if (mConnectedThread != null) {
					mConnectedThread.cancel();
					mConnectedThread = null;
				}

				/* Close the socket */
				mSocket.close();

				/* Set the connected state */
				connected = false;
				/* If it successfully closes I guess we just return a success? */
				//return 0;
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				/* Otherwise we'll go ahead and say "no, this didn't work well!" */
				//return 1;
			}
		}
	}

	/**
	 * Kills the main thread. Shouldn't stop when the connection disconnects,.
	 * or should it?
	 * 
	 * @return
	 */
	public void stop() {

	}
	
	
	
	
	private String execCode(String code, boolean answer){
		String returnCode = "";
		
		try{
			 returnCode = client.sendDandelion(code,answer);
			 if(DEBUG){
				 System.out.println("exec Code " + code);
			 }
		}catch(TimeoutException e){
			System.out.println("exec Code " + code + " TIMEOUT!");
		}catch(IOException e){
		//	errorMessage("I/O error!!");
		}

		return returnCode;
	}
	
	
	//display error message and exit
	private void errorMessage(String message){
		System.out.println(message);
		System.exit(-1);
	}
	
	//
	private void interpretCode(String code){
		
		StringBuffer codeBuffer = new StringBuffer(code); 
		while(codeBuffer.indexOf("\n")!=-1){
			String iCode = codeBuffer.substring(0, codeBuffer.indexOf("\n"));
			codeBuffer.delete(0, codeBuffer.indexOf("\n")+1);
		
			if(iCode.startsWith("i")||iCode.startsWith("I")){
				
				String value;
				for(int i=0;i<analogInput.length;i++){
					value = iCode.substring(2*i+1,2*(i+1)+1);
					analogInput[i] = Integer.parseInt(value,16);
				}
				
				if(DandelionAnalogInputMethod != null){
					try{
						DandelionAnalogInputMethod.invoke(ctx,new Object[]{ analogInput });
					}catch(Exception e){
						e.printStackTrace();
						DandelionAnalogInputMethod = null;
						errorMessage("DandelionAnalogInputEvent error!!");
					}
				}
				
			}else if(iCode.startsWith("r")||iCode.startsWith("R")){

				int value = Integer.parseInt(iCode.substring(1,5),16);
				for(int i=0;i<digitalInput.length;i++){
					int c = 1&(value>>i);
					if(c==1){
						digitalInput[i] = true;
					}else{
						digitalInput[i] = false;
					}
				}
				if(DandelionDigitalInputMethod != null){
					try{
						DandelionDigitalInputMethod.invoke(ctx,new Object[]{ digitalInput });
					}catch(Exception e){
						e.printStackTrace();
						DandelionDigitalInputMethod = null;
						errorMessage("DandelionDigitalInputEvent error!!");
					}
				}


			/*	
			// added by morecat
			}else if(iCode.startsWith("E")){ // E* ... polling done
			// System.out.println("E* command is detected");
				continuousMode = false;	*/
			}
		}

	}
	
	/**
	 * Sample values of all digital channels. The value will be stored in array "digitalInput".
	 */
	public void peekDigitalInput(){
		interpretCode(execCode("R\n",false));
	}
	
	public void beginDigitalInput(){
		continuousMode = true; // morecat
		execCode("r\n",false);
	}
	
	public void endDigitalInput(){
		execCode("E\n",false);
	}
	
	public void beginAnalogInput(){
		continuousMode = true;
		execCode("i\n",false);
	}
	
	public void endAnalogInput(){
		execCode("E\n",false);
	}
	
	/**
	 * Sample values of all analog channels. The value will be stored in array "analogInput".
	 */
	public void peekAnalogInput(){
		interpretCode(execCode("I\n",false));
	}
	
	/**
	 * Put specified channel High. Also it will be set as an output channel.
	 * @param channel
	 *          the number of digital channel 
	 */
	public boolean setHigh(int channel){
		if(digitalOutput.length>channel){
			String code = "H" + Integer.toHexString(channel).toUpperCase() + "\n";
			execCode(code,false);
			// A redundant?
			digitalOutput[channel] = true;
			return true;
		}
		return false;
	}
	/**
	 * Put specified channel Low. Also it will be set as an output channel.
	 * @param channel
	 *          the number of digital channel 
	 */
	public boolean setLow(int channel){
		if(digitalOutput.length>channel){
			String code = "L" + Integer.toHexString(channel).toUpperCase() + "\n";
			execCode(code,false);
			// A redundant?
			digitalOutput[channel] = true;
			return true;
		}
		return false;
	}
	
	
	public synchronized void putReturnCode(){
//		System.out.println("putReturnCode BEGIN  " + Thread.currentThread().getName());	

			byte temp[] = new byte[64];
			int read_count=client.available();
			temp=client.readBytes();

			sReturnCodes.append(new String(temp,0,read_count));


		int indexStar = sReturnCodes.indexOf("\n");
		if(indexStar != -1){
			//notifyAll();
			

			
			interpretCode(getReturnCode());
		}
		
//		System.out.println("putReturnCode END");
	}
	
	public synchronized String getReturnCode(){
	
		String returnCode = sReturnCodes.substring(0, sReturnCodes.lastIndexOf("\n")+1);
		sReturnCodes.delete(0, sReturnCodes.lastIndexOf("\n")+1);
		
		return returnCode;
	}
	
	
	
}

